#ifndef _MFW_GST_M2VPARSER_H_
#define _MFW_GST_M2VPARSER_H_

/*
 * Copyright 2005-2007 Freescale Semiconductor, Inc. All Rights Reserved.
 */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/*=============================================================================
                                                                               
    Header Name:    mfw_gst_m2vparser.h

    General Description:    This Header file contains the code for integrating the 
                            M2V Parser Plugin with GStreamer. 
 
===============================================================================

==============================================================================
                                         INCLUDE FILES
=============================================================================*/
/* None */

/*=============================================================================
                                           CONSTANTS
=============================================================================*/
#define MAX_STREAM_BUF 512
/* None. */
  
/*=============================================================================
                                            MACROS
=============================================================================*/

G_BEGIN_DECLS

#define MFW_GST_TYPE_M2VPARSER (mfw_gst_m2vparser_get_type())

#define MFW_GST_M2VPARSER(obj) \
(G_TYPE_CHECK_INSTANCE_CAST((obj),MFW_GST_TYPE_M2VPARSER,MFW_GST_M2VPARSER_INFO_T))

#define MFW_GST_M2VPARSER_CLASS(klass) \
(G_TYPE_CHECK_CLASS_CAST((klass),MFW_GST_TYPE_M2VPARSER,MFW_GST_M2VPARSER_INFO_T))

#define MFW_GST_IS_M2VPARSER(obj) \
(G_TYPE_CHECK_INSTANCE_TYPE((obj),MFW_GST_TYPE_M2VPARSER))

#define MFW_GST_IS_M2VPARSER_CLASS(klass) \
(G_TYPE_CHECK_CLASS_TYPE((klass),MFW_GST_TYPE_M2VPARSER))

/*=============================================================================
                                             ENUMS
=============================================================================*/
/* None */
/*=============================================================================
                                 STRUCTURES AND OTHER TYPEDEFS
=============================================================================*/

typedef struct MFW_GST_M2VPARSER_INTO_S
{
	GstElement		    element;            /* instance of base class */        
	GstPad			    *sinkpad;           /* sink pad of element*/
    GstPad              *srcpad;            /* source pad of element*/
	gint64 			    total_duration;	    /* total duration of stream */
	gboolean		    caps_set;           /* cabability setting */
	gint32			    offset;             /* current position of stream */
    gint32              buffstart;          
    gboolean            new_seg_flag;       /* new segment event flag */
    guint               decoded_frames;     /* number of frames decoded */
    gfloat              framerate;          /* frame rate @ which i/p is 
                                               to be displayed */
    gint64              buff_index;         /* points to the data start of 
                                               1 buffer (4096 )worth of data */ 
    GstAdapter *adapter;	/* adapter to queue in the buffers */

    gboolean first_time;
    gboolean flag;
    gfloat frame_rate;	

    GstClockTime timestamp_buffer[MAX_STREAM_BUF];	/* array to hold timestamps */
    gint32 timestamp_tx;	/* index for received timestamp */
    GstClockTime timestamp_duration;
    gint32 loop_chain;			
	GstClockTime timestamp_org;

	gint32 frame_rate_de ;
    gint32 frame_rate_nu ;
    
   //  gint32 i_loop  ;
}MFW_GST_M2VPARSER_INFO_T;

typedef struct MFW_GST_M2VPARSER_INFO_CLASS_S 
{
	GstElementClass parent_class;
} MFW_GST_M2VPARSER_INFO_CLASS_T;

 

/*=============================================================================
                                 GLOBAL VARIABLE DECLARATIONS
=============================================================================*/

/* None. */

/*=============================================================================
                                     FUNCTION PROTOTYPES
=============================================================================*/
/* None. */

/*===========================================================================*/

G_END_DECLS
#endif  /* _MFW_GST_M2VPARSER_H_ */
